<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/utils.hpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('utils_8hpp.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">utils.hpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;SDL2/SDL.h&quot;</code><br />
<code>#include &quot;<a class="el" href="_ray_tracer_8hpp_source.html">RayTracer.hpp</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_scene_8hpp_source.html">Scene.hpp</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_vec_8hpp_source.html">Vec.hpp</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_transform_8hpp_source.html">Transform.hpp</a>&quot;</code><br />
</div>
<p><a href="utils_8hpp_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:adbd1409868b52e433ed84baf91620dff"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="utils_8hpp.html#adbd1409868b52e433ed84baf91620dff">main_loop</a> (<a class="el" href="class_ray_tracer.html">RayTracer</a> &amp;renderer, void(*callback)(<a class="el" href="class_ray_tracer.html">RayTracer</a> *, SDL_Event &amp;), bool view_look_at_sphere, bool refresh_bvh, bool default_events)</td></tr>
<tr class="separator:adbd1409868b52e433ed84baf91620dff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37bdfd1760746e99eb5ca412b996b518"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="utils_8hpp.html#a37bdfd1760746e99eb5ca412b996b518">LightBulb</a> (<a class="el" href="class_scene.html">Scene</a> *scene, const <a class="el" href="class_vec.html">Vec</a> &amp;pos, const <a class="el" href="class_vec.html">Vec</a> &amp;cl, double decay, <a class="el" href="class_transform.html">Transform</a> *tf)</td></tr>
<tr class="memdesc:a37bdfd1760746e99eb5ca412b996b518"><td class="mdescLeft">&#160;</td><td class="mdescRight">Associates a <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> object with a <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> to create a light bulb.  <a href="#a37bdfd1760746e99eb5ca412b996b518">More...</a><br /></td></tr>
<tr class="separator:a37bdfd1760746e99eb5ca412b996b518"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:affc96c8859e998422a378d17baf5cb15"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="utils_8hpp.html#affc96c8859e998422a378d17baf5cb15">CornellBox</a> (<a class="el" href="class_scene.html">Scene</a> *scene, <a class="el" href="class_transform.html">Transform</a> *tf)</td></tr>
<tr class="memdesc:affc96c8859e998422a378d17baf5cb15"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a simple Cornell <a class="el" href="class_box.html">Box</a>.  <a href="#affc96c8859e998422a378d17baf5cb15">More...</a><br /></td></tr>
<tr class="separator:affc96c8859e998422a378d17baf5cb15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8bb50e55e89fa38966a77ec9f4b96c6d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="utils_8hpp.html#a8bb50e55e89fa38966a77ec9f4b96c6d">CornellBoxTextured</a> (<a class="el" href="class_scene.html">Scene</a> *scene, <a class="el" href="class_transform.html">Transform</a> *tf)</td></tr>
<tr class="memdesc:a8bb50e55e89fa38966a77ec9f4b96c6d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a textured Cornell <a class="el" href="class_box.html">Box</a>.  <a href="#a8bb50e55e89fa38966a77ec9f4b96c6d">More...</a><br /></td></tr>
<tr class="separator:a8bb50e55e89fa38966a77ec9f4b96c6d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa94606ba1e128dfa257cc54b1123a4e0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="utils_8hpp.html#aa94606ba1e128dfa257cc54b1123a4e0">print_matrix</a> (std::vector&lt; int &gt; level_matrix)</td></tr>
<tr class="separator:aa94606ba1e128dfa257cc54b1123a4e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb666dff602c2d32f3a90c1a1aa11736"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="utils_8hpp.html#abb666dff602c2d32f3a90c1a1aa11736">drawBox</a> (<a class="el" href="class_scene.html">Scene</a> *scene, <a class="el" href="class_material.html">Material</a> *m, <a class="el" href="class_box.html">Box</a> box)</td></tr>
<tr class="memdesc:abb666dff602c2d32f3a90c1a1aa11736"><td class="mdescLeft">&#160;</td><td class="mdescRight">Draws a given bounding box of type <a class="el" href="class_box.html">Box</a>.  <a href="#abb666dff602c2d32f3a90c1a1aa11736">More...</a><br /></td></tr>
<tr class="separator:abb666dff602c2d32f3a90c1a1aa11736"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="affc96c8859e998422a378d17baf5cb15"></a>
<h2 class="memtitle"><span class="permalink"><a href="#affc96c8859e998422a378d17baf5cb15">&sect;&nbsp;</a></span>CornellBox()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CornellBox </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>scene</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>tf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Creates a simple Cornell <a class="el" href="class_box.html">Box</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> in which the light bulb will be appended </td></tr>
    <tr><td class="paramname">tf</td><td>Pointer to <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object responsible for controlling the pose/scale of the light bulb (set to NULL if unwanted) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8bb50e55e89fa38966a77ec9f4b96c6d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8bb50e55e89fa38966a77ec9f4b96c6d">&sect;&nbsp;</a></span>CornellBoxTextured()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CornellBoxTextured </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>scene</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>tf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Creates a textured Cornell <a class="el" href="class_box.html">Box</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> in which the light bulb will be appended </td></tr>
    <tr><td class="paramname">tf</td><td>Pointer to <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object responsible for controlling the pose/scale of the light bulb (set to NULL if unwanted) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="abb666dff602c2d32f3a90c1a1aa11736"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abb666dff602c2d32f3a90c1a1aa11736">&sect;&nbsp;</a></span>drawBox()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void drawBox </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>scene</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_box.html">Box</a>&#160;</td>
          <td class="paramname"><em>box</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Draws a given bounding box of type <a class="el" href="class_box.html">Box</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> in which the light bulb will be appended </td></tr>
    <tr><td class="paramname">m</td><td>Pointer to <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> used to paint the <a class="el" href="class_box.html">Box</a> </td></tr>
    <tr><td class="paramname">box</td><td>Pointer to the <a class="el" href="class_box.html">Box</a> object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a37bdfd1760746e99eb5ca412b996b518"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a37bdfd1760746e99eb5ca412b996b518">&sect;&nbsp;</a></span>LightBulb()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void LightBulb </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_scene.html">Scene</a> *&#160;</td>
          <td class="paramname"><em>scene</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>cl</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>decay</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>tf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Associates a <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> object with a <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> to create a light bulb. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">scene</td><td>Pointer to the <a class="el" href="class_scene.html" title="A class to create and control scenes from Surface and Light objects. ">Scene</a> in which the light bulb will be appended </td></tr>
    <tr><td class="paramname">pos</td><td>3D location of the light bulb </td></tr>
    <tr><td class="paramname">cl</td><td><a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a>'s intensity vector </td></tr>
    <tr><td class="paramname">decay</td><td>light intensity decay exponent </td></tr>
    <tr><td class="paramname">tf</td><td>Pointer to <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object responsible for controlling the pose/scale of the light bulb (set to NULL if unwanted) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="adbd1409868b52e433ed84baf91620dff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adbd1409868b52e433ed84baf91620dff">&sect;&nbsp;</a></span>main_loop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void main_loop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_ray_tracer.html">RayTracer</a> &amp;&#160;</td>
          <td class="paramname"><em>renderer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(<a class="el" href="class_ray_tracer.html">RayTracer</a> *, SDL_Event &amp;)&#160;</td>
          <td class="paramname"><em>callback</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>view_look_at_sphere</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>refresh_bvh</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>default_events</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Renders the scene and reacts to keyboard events in a cycle. The acceleration structure is updated at each new rendering cycle depending on the value of the refresh_bhv flag. This flag should be true if the scene contains animated elements.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">renderer</td><td><a class="el" href="class_ray_tracer.html" title="A class to create and manipulate surface materials. ">RayTracer</a> object responsible for the rendering of the scene </td></tr>
    <tr><td class="paramname">callback</td><td>Pointer to user-space function that will be called before each new rendering </td></tr>
    <tr><td class="paramname">view_look_at_sphere</td><td>Flag stating whether the user wants to view the look_at_sphere </td></tr>
    <tr><td class="paramname">refresh_bvh</td><td>Flag stating whether the acceleration structure should be updated at each new rendering cycle. </td></tr>
    <tr><td class="paramname">default_events</td><td>Flag stating whether default keyboard/mouse events should be on (such as setting anti-alliasing if key 'd' is pressed). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa94606ba1e128dfa257cc54b1123a4e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa94606ba1e128dfa257cc54b1123a4e0">&sect;&nbsp;</a></span>print_matrix()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_matrix </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; int &gt;&#160;</td>
          <td class="paramname"><em>level_matrix</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="utils_8hpp.html">utils.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
